# DND interaction - Feature Code to FOP2
$AMI_Event_Handler{'ombutel'}{'DEVICESTATECHANGE'} = sub { 
 
    #127.0.0.1            <- Device: Custom:DND_2000 
    #127.0.0.1            <- State: BUSY 
    my $event = shift;
    my @allreturn = ();
    my $device = ${$event}{'Device'};
    my $state  = ${$event}{'State'};
    my $extension = '';
    if( $device =~ m/Custom:DND/ ) {
        my @partes = split(/_/,$device);
        $extension = $partes[1];

        my $channel = main::get_btn_channel('GENERAL',$extension);
        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: FOP2ASTDB\r\n";
        $return .= "Channel: $channel\r\n";
        $return .= "Family: fop2state\r\n";
        if($state eq "BUSY") {
            $return .= "Value: Do not Disturb\r\n";
        } else {
            $return .= "Value: \r\n";
        }
        $return .= "\r\n";
        push @allreturn, $return;

        if($state eq "BUSY") {
            $return  = "Action: DBPut\r\n";
            $return .= "Family: fop2state\r\n";
            $return .= "Key: $channel\r\n";
            $return .= "Val: Do not Disturb\r\n";
            $return .= "\r\n";
        } else {
            $return  = "Action: DBDel\r\n";
            $return .= "Family: fop2state\r\n";
            $return .= "Key: $channel\r\n";
            $return .= "\r\n";
        }
        push @allreturn, $return;

    }

    return @allreturn;
};

# DND Interaction - FOP2 to Feature Code/Asterisk

$Client_Pre_Command_Handler{'ombutel'}{'setastdb'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my ($key,$thisexten,$data) = split(/~/,$destino);

    if($key eq "fop2state") {
        if ( $data =~ m/^([A-Za-z0-9+\/]{4})*([A-Za-z0-9+\/]{4}|[A-Za-z0-9+\/]{3}=|[A-Za-z0-9+\/]{2}==)$/ ) {
            $data = FOP2::utils::decode_base64($data);
        }

        my $btn_cfg = main::get_btn_config();
        my $tenanthash = ${btn_cfg}->{$contexto}[$origen]->{'CUSTOMASTDB'};
        
        if ($data eq "") {
            $return  = "Action: DBPut\r\n";
            $return .= "Family: $tenanthash/diversions/$thisexten/DND\r\n";
            $return .= "Key: enable\r\n";
            $return .= "Val: no\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            system("/usr/share/ombutel/scripts/synchronizer 'disable-DND' '$thisexten'");

            $return  = "Action: Command\r\n";
            $return .= "Command: devstate change Custom:DND_$thisexten NOT_INUSE\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

        } else {

            $return  = "Action: DBPut\r\n";
            $return .= "Family: $tenanthash/diversions/$thisexten/DND\r\n";
            $return .= "Key: enable\r\n";
            $return .= "Val: yes\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            system("/usr/share/ombutel/scripts/synchronizer 'enable-DND' '$thisexten'");

            $return  = "Action: Command\r\n";
            $return .= "Command: devstate change Custom:DND_$thisexten BUSY\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

        }

    }
    return @allreturn;

};

$AMI_Event_Handler{'ombutel'}{'NEWEXTEN'} = sub {
    my $event = shift;
    my @allreturn = ();

    if(defined(${$event}{'Application'})) {
        my $data = ${$event}{'AppData'};
        if ( index($data, '/usr/share/ombutel/scripts/synchronizer hotdesk-extension') > -1 ) {

            if( $data =~ m/^\/usr\/share\/ombutel\/scripts\/synchronizer hotdesk-extension "([^"]*)" "([^"]*)" "([^"]*)"/ ) {

                my $channel = $2."/".$1;
                my $user    = $3;

                if($user ne "") {
                    my $return = { 'Action' => 'UserEvent', 'UserEvent' => 'UserDeviceAdded', 'Data' => "$user,$channel" };
                    push @allreturn, $return;
                } else {
                    $user = $main::groupchannel{$channel};
                    $user =~ s/USER\///g;
                    my $return = { 'Action' => 'UserEvent', 'UserEvent' => 'UserDeviceRemoved', 'Data' => "$user," };
                    push @allreturn, $return;
                }
            } 
        } 
    }

    return @allreturn;

};
